<template>
  <section class="wrapper" :class="{ 'wrapper--mobile': device == 'mobile' }">
    <h1 class="title">Le / Tip</h1>

    <div class="row">
      <InputPanel
        class="panel"
        :class="{ 'panel--mobile': device == 'mobile' }"
        v-if="showInputPanel"
        :account="account"
        :currency="currency"
        :switchState="switchChecked"
        @update="getInputPanelPayload"
      />

      <OutputPanel
        class="panel"
        :class="{ 'panel--mobile': device == 'mobile' }"
        v-if="showResultPanel"
        :currency="currency"
        :totalAccount="totalAccount"
        :totalBRL="totalBRL"
        :totalFinal="totalFinal"
        :totalPerPerson="totalPerPerson"
        :totalTip="totalTip"
      />
    </div>

    <ButtonNav
      v-if="device == 'mobile'"
      class="button-device"
      :class="{ 'button-device--prev': this.tab.active == 'resultPanel' }"
      @click="onChangeTab"
    >
    </ButtonNav>
  </section>
</template>

<script>
import { currencyConversion } from "../queries/currencyConversion";
import InputPanel from "@/components/InputPanel";
import OutputPanel from "@/components/OutputPanel";

export default {
  name: "IndexPage",
  components: {
    InputPanel,
    OutputPanel,
  },
  data() {
    return {
      currency: {
        code: "USD",
        rate: 0,
        symbol: "$",
      },
      account: {
        personQuantity: 2,
        tipPercent: 10,
        value: 0,
      },
      tab: {
        active: "inputPanel",
      },
      switchChecked: true,
      device: "desktop",
    };
  },
  watch: {
    async switchChecked() {
      this.updateCurrencyCode();
      await this.getData();
    },
  },
  methods: {
    async getData() {
      const query = currencyConversion(this.currency.code);

      try {
        const response = await this.$axios.post("/graphql", { query });
        const conversion = response.data.data.currencyConversion.conversions[0];
        const { rate, currencyInfo } = conversion;
        this.currency = { ...currencyInfo, rate };
      } catch {}

    },
    getInputPanelPayload(payload) {
      const { account, currency, switchState } = payload;

      this.account = { ...account };
      this.currency = { ...currency };
      this.switchChecked = switchState;
    },
    updateCurrencyCode() {
      this.currency.code = this.switchChecked ? "USD" : "EUR";
    },
    fixFloatError(value) {
      return Math.round(value * 100) / 100;
    },
    onChangeTab() {
      this.tab.active =
        this.tab.active == "inputPanel" ? "resultPanel" : "inputPanel";
    },
    checkDevice(event) {
      const sizeScreen =
        event.target.innerWidth || event.target.defaultView.innerWidth;
      this.device = sizeScreen <= 768 ? "mobile" : "desktop";
    },
  },
  computed: {
    totalAccount() {
      if (isNaN(parseFloat(this.account.value))) return 0;

      const total = parseFloat(this.account.value);

      return this.fixFloatError(total);
    },
    totalBRL() {
      const total = this.totalPerPerson * this.currency.rate;

      return this.fixFloatError(total);
    },
    totalFinal() {
      const total = this.totalAccount + this.totalTip;

      return this.fixFloatError(total);
    },
    totalPerPerson() {
      const total = this.totalFinal / parseInt(this.account.personQuantity, 10);

      return this.fixFloatError(total);
    },
    totalTip() {
      if (isNaN(parseFloat(this.account.value))) return 0;

      let tip = parseFloat(this.account.value) / 100;
      tip *= parseInt(this.account.tipPercent, 10);

      return this.fixFloatError(tip);
    },
    showInputPanel() {
      return (
        this.device == "desktop" ||
        (this.device == "mobile" && this.tab.active == "inputPanel")
      );
    },
    showResultPanel() {
      return (
        this.device == "desktop" ||
        (this.device == "mobile" && this.tab.active == "resultPanel")
      );
    },
  },
  async mounted() {
    window.addEventListener("load", this.checkDevice);
    window.addEventListener("resize", this.checkDevice);
    await this.getData();
  },
  destroyed() {
    window.addEventListener("resize", this.checkDevice);
  },
};
</script>

<style lang="scss" scoped>
.wrapper {
  width: 100%;
  height: 100vh;
  max-width: 992px;
  margin: 0 auto;
  position: relative;
  display: flex;
  flex-direction: column;

  &--mobile {
    justify-content: center;
  }
}

.title {
  text-align: center;
  font-size: 3rem;
  padding: 1.5rem 0;
  margin-bottom: 0.5rem;
}

.button-device {
  position: absolute;
  bottom: 40px;
  right: 40px;

  &--prev {
    transform: scaleX(-1);
  }
}

.panel {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 50%;
  min-width: 345px;

  &--mobile {
    width: 100%;
    flex-direction: column;
    gap: 50px;
  }
}
</style>
